/* Resources which are (similar to) bitmaps reside in the Abalone.rsrc file,
 * and don't have a corresponding Rez definition.
 */
include "Abalone.rsrc" not 'ckid'; /* insert 'bitmap'-like resources */
#include "BalloonTypes.r"
#include "SysTypes.r"
#include "Types.r"

#include "Define.h"
#include "Menu.h"


type 'A1e' as 'STR ';
type 'mstr' as 'STR ';


resource 'A1e' (0)
{
	"Abalone for the Macintosh"
};


resource 'STR ' (-16396, purgeable)
{
	"Abalone"
};


resource 'vers' (1)
{
	0x1,
	0x4,
	final,
	0x2,
	verNetherlands,
	"1.4.2",
	"Version 1.4.2\n 1993-1995 Peter Tax"
};


resource 'vers' (2)
{
	0x1,
	0x4,
	final,
	0x2,
	verNetherlands,
	"1.4.2",
	"The board game on your Macintosh"
};


resource 'BNDL' (128, purgeable)
{
	'A1e',
	0,
	{
		'FREF',
		{
			0, 128,
			1, 129,
			2, 130
		},
		'ICN#',
		{
			0, 128,
			1, 129,
			2, 130
		}
	}
};


resource 'FREF' (128, purgeable)
{
	'APPL',
	0,
	"Abalone Appl"
};


resource 'FREF' (129, purgeable)
{
	'oo',
	1,
	"Abalone Pref"
};


resource 'FREF' (130, purgeable)
{
	'o',
	2,
	"Abalone Game"
};


resource 'SIZE' (-1)
{
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};


resource 'MBAR' (rMenuBar, preload)
{
	{
    	APPLE_MENU;
    	FILE_MENU;
		EDIT_MENU;
		SETTINGS_MENU;
		OPTION_MENU;
		COLOR_MENU;
		BACKGROUND_MENU;
	};
};


resource  'MENU' (APPLE_MENU, preload)
{
    $$ID,
    textMenuProc,
    AllItems & ~MenuItem3,
    enabled,
    apple,
    {
		"About the game", noIcon, hierarchicalMenu, "\0D220", plain;
		"About this program", noIcon, hierarchicalMenu, "\0D230", plain;
		"-", noIcon, noKey, noMark, plain
    }
};


resource	'STR#' (ABOUT_ABALONE_MENU, "about abalone", preload)
{
	{
		"Rules of Abalone";
		"Rules for moving";
		"Rules for pushing";
	}
};



resource	'STR#' (ABOUT_PROGRAM_MENU, "about program", preload)
{
	{
		"Copyright";
		"Author";
		"Making moves";
		"Configuring";
		"Network play";
		"Strategies";
		"Trademark";
	}
};



resource  'MENU' (FILE_MENU, preload)
{
    $$ID,
    textMenuProc,
    AllItems & ~MenuItem3 & ~MenuItem6,
    enabled,
    "File",
    {
		"New Game", 6, "N", noMark, plain;
		"Open Game", 15, "O", noMark, plain;
		"-", noIcon, noKey, noMark, plain;
		"Save Game", 16, "S", noMark, plain;
		"Save Game as", 16, noKey, noMark, plain;
		"-", noIcon, noKey, noMark, plain;
		"Quit Abalone", 17, "Q", noMark, plain
    }
};


resource 'MENU' (EDIT_MENU, preload)
{
    $$ID,
	textMenuProc,
	MenuItem1,
	enabled,
	"Edit",
	 {
		"Undo", 4, "Z", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Cut", noicon, "X", nomark, plain;
		"Copy", noicon, "C", nomark, plain;
		"Paste", noicon, "V", nomark, plain;
		"Clear", noicon, nokey, nomark, plain
	}
};


resource 'MENU' (SETTINGS_MENU, preload)
{
    $$ID,
	textMenuProc,
	AllItems & ~MenuItem4,
	enabled,
	"Settings",
	 {
		"First Player", 1, "1", nomark, plain;
		"Second Player", 2, "2", nomark, plain;
		"Third Player", 3, "3", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Two Players", 6, nokey, nomark, plain;
		"Three Players", 7, nokey, nomark, plain;
	}
};


resource 'MENU' (OPTION_MENU, preload)
{
    $$ID,
	textMenuProc,
	AllItems,
	enabled,
	"Options",
	{
		"Sound", 8, noKey, nomark, plain;
		"Nicer Graphics", 9, noKey, nomark, plain;
		"Show Notation", 10, noKey, nomark, plain;
	}
};


resource 'MENU' (COLOR_MENU, preload)
{
    $$ID,
	textMenuProc,
	AllItems,
	enabled,
	"Color",
	{
		"First Player", 1, nokey, nomark, plain;
		"Second Player", 2, nokey, nomark, plain;
		"Third Player", 3, nokey, nomark, plain;
		"-", noIcon, noKey, noMark, plain;
		"Background", 5, nokey, nomark, plain
	}
};


resource 'MENU' (BACKGROUND_MENU, preload)
{
    $$ID,
	textMenuProc,
	AllItems,
	enabled,
	"Background",
	{
		"Select Picture", 14, "B", nomark, plain
	}
};


resource 'MENU' (PLAYER_MENU, preload)
{
	$$ID,
	textMenuProc,
	allEnabled,
	enabled,
	"Player",
	{
		"Homo Sapiens", noIcon, noKey, noMark, plain;
		"On the Network", noIcon, noKey, noMark, plain;
		"This Macintosh", noIcon, noKey, noMark, plain;
	}
};


resource 'MENU' (STRATEGY_MENU, preload)
{
	$$ID,
	textMenuProc,
	allEnabled,
	enabled,
	"Strategy",
	{
	//	Filled in on-the-fly
	}
};


resource 'MENU' (LEVEL_MENU, preload)
{
	$$ID,
	textMenuProc,
	allItems,
	enabled,
	"Thought Level",
	{
		"1 Ply", noIcon, noKey, noMark, plain;
		"2 Plies", noIcon, noKey, noMark, plain;
		"3 Plies", noIcon, noKey, noMark, plain;
		"4 Plies", noIcon, noKey, noMark, plain;
		"5 Plies", noIcon, noKey, noMark, plain;
//		"6 Plies", noIcon, noKey, noMark, plain;
//		"7 Plies", noIcon, noKey, noMark, plain;
//		"8 Plies", noIcon, noKey, noMark, plain;
//		"9 Plies", noIcon, noKey, noMark, plain;
	}
};



//resource 'MENU' (NETTEST_MENU, preload)
//{
//    $$ID,
//	textMenuProc,
//	AllItems,
//	enabled,
//	"NetTest",
//	{
//		"Connect", noIcon, "N", noMark, plain;
//		"-", noIcon, noKey, noMark, plain;
//		"Send Move", noIcon, "M", noMark, plain;
//		"Send Game", noIcon, "G", noMark, plain;
//		"Send Undo", noIcon, "U", noMark, plain
//	}
//};


resource 'dctb' (rWindow, "abalone", preload)
{
	{
		wContentColor, 32767, 32767, 32767,
		wFrameColor, 0, 0, 0,
		wTextColor, 0, 0, 0,
		wHiliteColor, 0, 0, 0,
		wTitleBarColor, 65535, 65535, 65535
	}
};


resource 'DLOG' (rWindow, "abalone", preload)
{
	{40, 10, 335, 344},
	zoomNoGrow,
	invisible,
	goAway,
	0x0,
	1000,
	"Abalone",
	noAutoCenter
};


resource 'DITL' (1000, "abalone", preload)
{
	{
		{1, 1, 10, 10},
		UserItem {
			disabled
		},
		{1, 11, 10, 20},
		UserItem {
			disabled
		};
		{1, 21, 10, 30},
		UserItem {
			disabled
		};
		{1, 1, 20, 70},
		UserItem {
			disabled
		}
	}
};


resource 'DLOG' (ABOUT_ABALONE_MENU, "about abalone (large)", purgeable)
{
	{0, 00, 360, 470},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	ABOUT_ABALONE_MENU,
	"About",
	alertPositionParentWindow
};


resource 'dctb' (ABOUT_ABALONE_MENU, "about abalone (large)", purgeable)
{
	{
		wContentColor, 63587, 65535, 65535,
		wFrameColor, 0, 0, 0,
		wTextColor, 0, 0, 0,
		wHiliteColor, 0, 0, 0,
		wTitleBarColor, 32767, 32767, 32767
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU, "about abalone (large)", purgeable)
{
	{
		{64, 00, 70, 470},
		Picture {
			disabled,
			219
		},
		{330, 300, 354, 460},
		Button {
			enabled,
			"Back to the Board"
		},
		{330, 10, 354, 110},
		Button {
			enabled,
			"Prior item"
		},
		{330, 140, 354, 240},
		Button {
			enabled,
			"Next item"
		},
		{5, 30, 60, 417},
		Picture {
			disabled,
			220
		},
	}
};


resource 'DLOG' (ABOUT_ABALONE_MENU - 1, "about abalone (small)", purgeable)
{
	{0, 0, 306, 470},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	ABOUT_ABALONE_MENU - 1,
	"About",
	alertPositionParentWindow
};

resource 'dctb' (ABOUT_ABALONE_MENU - 1, "about abalone (small)", purgeable)
{
	{
		wContentColor, 63587, 65535, 65535,
		wFrameColor, 0, 0, 0,
		wTextColor, 0, 0, 0,
		wHiliteColor, 0, 0, 0,
		wTitleBarColor, 32767, 32767, 32767
	}
};

resource 'DITL' (ABOUT_ABALONE_MENU - 1, "about abalone (small)", purgeable)
{
	{
		{9, 0, 25, 0},
		StaticText {
			disabled,
			" "
		},
		{280, 300, 304, 460},
		Button {
			enabled,
			"Back to the Board"
		},
		{280, 10, 304, 110},
		Button {
			enabled,
			"Prior item"
		},
		{280, 140, 304, 240},
		Button {
			enabled,
			"Next item"
		},
		{4, 130, 20, 464},
		StaticText {
			disabled,
			"About Abalone for the Macintosh"
		},
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 1, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 2, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 3, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 1, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 2, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		},
		{150, 100, 182, 132},
		Icon {
			disabled,
			300
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 3, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 4, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		},
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 5, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		},
		{30, 30, 62, 62},
		Icon {
			disabled,
			400
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 6, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		},
		{21, 28, 85, 92},
		Picture {
			disabled,
			218
		}
	}
};


resource 'DITL' (ABOUT_ABALONE_MENU + 10 + 7, purgeable)
{
	{
		{10, 10, 260, 460},
		Picture {
			disabled,
			$$ID
		}
	}
};


resource 'DLOG' (200, "player settings", purgeable)
{
	{58, 95, 228, 416},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	$$ID,
	"",
	alertPositionParentWindow
};


resource 'DITL' (200, "player settings", purgeable)
{
	{	
		{140, 250, 160, 308},
		Button {
			enabled,
			"OK"
		},
		{140, 170, 160, 228},
		Button {
			enabled,
			"Cancel"
		},
		{15, 15, 80, 80},
		UserItem {
			enabled
		},
		{50, 80, 70, 310},
		Control {
			enabled,
			202
		},
		{80, 70, 100, 310},
		Control {
			enabled,
			200
		},
		{110, 30, 130, 310},
		Control {
			enabled,
			201
		},
		{20, 95, 39, 140},
		StaticText {
			disabled,
			"Name:"
		},
		{20, 143, 35, 306},
		EditText {
			enabled,
			"Gonzo the Great"
		}
	}
};


resource 'ALRT' (201, "save game?", purgeable)
{
	{80, 80, 146, 456},
	$$ID,
	silentStages,
	alertPositionParentWindow
};


resource 'DITL' (201, "save game?", purgeable)
{
	{
		{40, 70, 60, 155},
		Button {
			enabled,
			"Dont Save"
		},
		{40, 290, 60, 360},
		Button {
			enabled,
			"Save"
		},
		{40, 210, 60, 280},
		Button {
			enabled,
			"Cancel"
		},
		{10, 70, 30, 372},
		StaticText {
			disabled,
			"Do you want to save the current game first?"
		}
	}
};


resource 'ALRT' (202, "end of game", purgeable)
{
	{50, 86, 175, 397},
	$$ID,
	silentStages,
	alertPositionParentWindow
};


resource 'DITL' (202, "end of game", purgeable)
{
	{
		{95, 210, 115, 293},
		Button {
			enabled,
			"New Game"
		},
		{95, 80, 115, 193},
		Button {
			enabled,
			"Undo last move"
		},
		{95, 10, 115, 65},
		Button {
			enabled,
			"Quit"
		},
		{10, 10, 42, 42},
		Icon {
			disabled,
			0
		},
		{20, 50, 72, 312},
		StaticText {
			disabled,
			"^0 has won this game.\n"
			"^1\n"
			"Feel free to play again."
		}
	}
};


resource 'DLOG' (203, "select picture", purgeable)
{
	{0, 0, 60, 456},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	$$ID,
	"About",
	alertPositionParentWindow
};


resource 'DITL' (rBackgroundSelect, "select picture", purgeable)
{
	{
		{13, 23, 40, 450},
		StaticText {
			disabled,
			"Select the background by clicking on one of the pictures below"
		}
	}
};


resource 'DITL' (rBackgroundSelectPict, "pict items", purgeable)
{
	{
		{30, 0*(20+122), 30+106, 0*(20+122)+122},
		Picture {
			enabled,
			200
		},
		{30, 1*(20+122), 30+106, 1*(20+122)+122},
		Picture {
			enabled,
			201
		},
		{30, 2*(20+122), 30+106, 2*(20+122)+122},
		Picture {
			enabled,
			202
		}
	}
};


resource 'ALRT' (400, "make connection", purgeable)
{
	{40, 40, 165, 455},
	$$ID,
	silentStages,
	alertPositionParentWindow
};



resource 'DITL' (400, "make connection", purgeable)
{
	{	
		{95, 250, 115, 400},
		Button {
			enabled,
			"Establish connection"
		},
		{95, 130, 115, 240},
		Button {
			enabled,
			"Wait for other"
		},
		{95, 10, 115, 120},
		Button {
			enabled,
			"Cancel net play"
		},
		{10, 20, 42, 52},
		Icon {
			disabled,
			$$ID
		},
		{10, 70, 76, 399},
		StaticText {
			disabled,
			"Some of the players are network players, but no program-to-program connection has been established so far.\n"
			"What would you like to do now?"
		}
	}
};



resource 'ALRT' (401, "connection broken", purgeable)
{
	{40, 40, 130, 423},
	$$ID,
	silentStages,
	alertPositionParentWindow
};



resource 'DITL' (401, "connection broken", purgeable)
{
	{	
		{60, 270, 80, 360},
		Button {
			enabled,
			"Take over"
		},
		{60, 170, 80, 260},
		Button {
			enabled,
			"Just Wait"
		},
		{60, 70, 80, 160},
		Button {
			enabled,
			"Quit Game"
		},
		{10, 20, 42, 52},
		Icon {
			disabled,
			$$ID
		},
		{10, 70, 47, 360},
		StaticText {
			disabled,
			"Sorry, your opponent broke the connection.\n"
			"Do you want this Mac to take over for him?"
		}
	}
};



resource 'ALRT' (402, "break connection?", purgeable)
{
	{40, 40, 150, 470},
	$$ID,
	silentStages,
	alertPositionParentWindow
};



resource 'DITL' (402, "break connection?", purgeable)
{
	{	
		{80, 310, 100, 410},
		Button {
			enabled,
			"Quit Game"
		},
		{80, 190, 100, 290},
		Button {
			enabled,
			"I'll behave"
		},
		{80, 70, 100, 170},
		Button {
			enabled,
			"Cancel"
		},
		{10, 20, 42, 52},
		Icon {
			disabled,
			400
		},
		{10, 70, 70, 429},
		StaticText {
			disabled,
			"You are playing with someone else on the network.\n"
			"Do you want to quit the game in progress?  If not,\n"
			"please don't mess up the board and reconnect soon."
		}
	}
};


resource 'ALRT' (403, "retry connecting?", purgeable)
{
	{40, 40, 182, 456},
	$$ID,
	silentStages,
	alertPositionParentWindow
};


resource 'DITL' (403, "retry connecting?", purgeable)
{
	{	
		{110, 250, 130, 400},
		Button {
			enabled,
			"Retry connecting"
		},
		{110, 130, 130, 240},
		Button {
			enabled,
			"Wait for other"
		},
		{110, 10, 130, 120},
		Button {
			enabled,
			"Cancel net play"
		},
		{10, 20, 42, 52},
		Icon {
			disabled,
			400
		},
		{10, 70, 96, 419},
		StaticText {
			disabled,
			"You did not establish a valid connection.\n"
			"If you have trouble connecting, then make sure\n"
			" Program Linking is turned on (Sharing Setup)\n"
			" Program Linking is allowed (Users & Groups)\n"
			"for all Macs and users involved."
		}
	}
};


resource 'ALRT' (404, "quit net game?", purgeable)
{
	{80, 80, 146, 456},
	$$ID,
	silentStages,
	alertPositionParentWindow
};


resource 'DITL' (404, "quit net game?", purgeable)
{
	{
		{40, 210, 60, 280},
		Button {
			enabled,
			"Cancel"
		},
		{40, 290, 60, 360},
		Button {
			enabled,
			"Quit"
		},
		{10, 20, 42, 52},
		Icon {
			disabled,
			400
		},
		{10, 70, 30, 372},
		StaticText {
			disabled,
			"Are you sure you want to quit this net game?"
		}
	}
};


resource 'hfdr' (-5696, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMSTRResItem
		{
			1001
		}
	}
};


resource 'STR ' (1001, purgeable)
{
	"Abalone is a nice strategic board game. This is a freeware Mac implementation of Abalone."
};


resource 'CNTL' (PLAYER_MENU)
{
	{60, 70, 80, 300},
	255,
	visible,
	60,
	$$ID,
	1008,
	0,
	"Player:"
};


resource 'CNTL' (STRATEGY_MENU)
{
	{60, 60, 80, 300},
	255,
	visible,
	70,
	$$ID,
	1008,
	0,
	"Strategy:"
};


resource 'CNTL' (LEVEL_MENU)
{
	{60, 20, 80, 300},
	255,
	visible,
	110,
	$$ID,
	1008,
	0,
	"Thought Level:"
};




resource 'STR#' (rPPCStrings, preload) 
{
	{
		"Please select your opponent's Abalone program on the network",
		"Opponents available",
	}
};
