/* Defines to be used by the C compiler and the resource compiler */


#define kMinSize				300						/* application's minimum size (in K) */
#define kPrefSize				750						/* application's preferred size (in K) */

#define	rMenuBar				128						/* application's menu bar */
#define	rAboutAlert				128						/* about alert */
#define rAboutLegalitiesAlert	129
#define rAboutRulesAlert		130
#define rAboutMeAlert			131
#define rAboutPlayingAlert		132
#define rAboutStrategiesAlert	133
#define	rUserAlert				129						/* error user alert */
#define	rWindow					128						/* application's window */
#define rPPCStrings				200
#define rBackgroundSelect		203
#define rBackgroundSelectPict	204
#define rConnection				400

/* kOSEvent is the event number of the suspend/resume and mouse-moved events sent
   by MultiFinder. Once we determine that an event is an osEvent, we look at the
   high byte of the message sent to determine which kind it is. To differentiate
   suspend and resume events we check the resumeMask bit. */

#define	kOSEvent				app4Evt	/* event used by MultiFinder */
#define	kSuspendResumeMessage	1		/* high byte of suspend/resume event message */
#define	kResumeMask				1		/* bit of message field for resume vs. suspend */
#define	kMouseMovedMessage		0xFA	/* high byte of mouse-moved event message */
   
   

/*	This is the minimum result from the following equation:
		
		ORD(GetApplLimit) - ORD(ApplicZone)
		
	for the application to run. It will insure that enough memory will
	be around for reasonable-sized scraps, FKEYs, etc. to exist with the
	application, and still give the application some 'breathing room'.
	To derive this number, we ran under a MultiFinder partition that was
	our requested minimum size, as given in the 'SIZE' resource. */
	 
#define kMinHeap				(200L * 1024)

/*	For this application, we may need a large stack. */

#define kPrefStack				(64L * 1024)
	
/*	1.01 - kMinSpace - This is the minimum result from PurgeSpace, when called
	at initialization time, for the application to run. This number acts
	as a double-check to insure that there really is enough memory for the
	application to run, including what has been taken up already by
	pre-loaded resources, the scrap, code, and other sundry memory blocks. */
	 
#define kMinSpace				(100 * 1024)

/* kExtremeNeg and kExtremePos are used to set up wide open rectangles and regions. */

#define kExtremeNeg				-32768
#define kExtremePos				(32767 - 1) /* required to address an old region bug */

#if defined(__MWERKS__)
#define Main	__%Main
#endif

//	Field sizes known to give a nice picture and corresponding window sizes.

#define kHorLarge				54
#define kHorSmall				38
#define kVerLarge				47
#define kVerSmall				33
#define kHorTotal				(9 * gSet.FieldWidth  + 2)
#define kVerTotal				(9 * gSet.FieldHeight + 1)				

