#ifndef FILE_H
#define FILE_H

#include "Game.h"
#include "Global.h"
#include "Rules.h"

#ifndef THINK_C
#include <Types.h>
#endif
#include <StandardFile.h>

void GetSettings (void);
//	Get the current settings from the Abalone Preferences file.

void PutSettings (void);
//	Store the current settings in the Abalone Preferences file.

#define brainNotPresentErr	666

OSErr	OpenGameFile (GamePtr game);
//	Tries to open a game file.

OSErr 	ReadGameFile (FSSpec *gameSpec, GamePtr game);

OSErr	SaveGameFile (GamePtr game);
//	Tries to save a given game using the currently open file. 
//	Calls SaveAsGame if no file open.

OSErr	SaveAsGameFile (GamePtr game);
//	Try to save a game.

#endif

#ifdef FILE_C

#include "Board.h"
#include "Define.h"
#include "Error.h"
#include "Global.h"
#include "Settings.h"

#ifndef THINK_C
#include <Errors.h>
#include <OSUtils.h>
#include <Packages.h>
#include <Resources.h>
#include <QuickDraw.h>
#include <String.h>
#endif
#include <Folders.h>
#include <Script.h>

void		ReadSettings (short prefRef);
void		WriteSettings (short prefRef);
void		GetResSettings (void);
void		PutResSettings (void);
OSErr		SaveSaveAs (StandardFileReply *reply, GamePtr game);
OSErr		WriteGame (short gameRef, GamePtr game);

#endif

