#ifndef GAME_H
#define GAME_H

#include "Board.h"

#ifndef THINK_C
#include <StandardFile.h>
#include <Types.h>
#endif

//	A game is mostly a board, but there is slightly more to it, like whose turn it is.

typedef struct _game
{
	BoardPtr		Board;
				//	Pointer to the current board.
					
	unsigned char	Players;
				//	The number of players in this game (2 or 3).
	
	unsigned char	CurrentPlayer;
				//	The player whose turn it is now.
	
	short			CurrentMove;
				//	Counter for the number of moves
	
}	Game, *GamePtr;


void			InitGame (void);
void			OpenGame (void);
OSErr			OpenGameSpec (FSSpec *specification);
void			SaveGame (void);
void			SaveGameAs (void);
unsigned char	CurrentPlayer (void);


#ifdef GAME_C

#include "Draw3D.h"
#include "Error.h"
#include "File.h"
#include "Global.h"
#include "Menu.h"
#include "Settings.h"

#ifndef THINK_C
#include <ToolUtils.h>
#endif

#else

extern Game	gTheGame;

#endif



#endif