#ifndef INTERFACE_H
#define INTERFACE_H


#include "Contest.h"
#include "Rules.h"

#ifndef THINK_C
#include <QuickDraw.h>
#include <String.h>
#include <Types.h>
#endif


void		InvalBoard (void);
void		UpdateBoard (WindowPtr window);
Boolean		FieldHasCurrentPlayersBall (Field f);
Rect 		FieldToRect (Field f);
Rect 		FieldToBallRect (Field f);
void		FrameHexagon (Rect *r);
void		DoFieldClick (Field f);
void		DoFieldShiftClick (Field f);
void		UndoLastMove (void);
void		InvalItems (WindowPtr window);
void		SizeItems (WindowPtr window);

pascal void	DrawBlackPoints (WindowPtr wp, short item);
pascal void	DrawWhitePoints (WindowPtr wp, short item);
pascal void	DrawGreenPoints (WindowPtr wp, short item);
pascal void DrawNotationItemProc (WindowPtr wp, short item);
//	User item procs to be installed in Abalone dialog.

void		RestoreColors (void);
short		PixelSize (void);

void 		ShowNotation (MovePtr, BoardPtr);
void		Lighten (RGBColor *color);
void		Darken (RGBColor *color);

#endif


#ifdef INTERFACE_C

#include "Compute.h"
#include "Connection.h"
#include "Draw3D.h"
#include "Error.h"
#include "File.h"
#include "Global.h"
#include "InsideMac.h"
#include "Menu.h"
#include "Settings.h"
#include "SoundPlay.h"

#ifndef THINK_C
#include <Events.h>
#include <Fonts.h>
#include <Memory.h>
#include <OSEvents.h>
#include <OSUtils.h>
#include <QuickDraw.h>
#include <StdIO.h>
#include <StdLib.h>
//#include <SysEqu.h>
#include <TextEdit.h>
#include <ToolUtils.h>
#include <Windows.h>
#endif


void	DrawBoard (BoardPtr);
void	DrawBall (Field field, char color);
void	DrawBallColor (Field field, char color);
//		DrawBallColor3D			has been moved to separate file Draw3D
void	DrawField (Field field);
void	DrawFieldColor (Field field);
//		DrawFieldColor3D			has been moved to separate file Draw3D
void	DrawFieldColor (Field field);
void	DrawGrid (Field field);
void	DrawGridColor (Field field);
void	DrawPoint (Rect * box, short color);
void	XORBall (Field field);
void	ShowMove (MovePtr move, Boolean animate);
void	ShowPropMove (Field f, short direction, Boolean animate);
void	ShowFlicheMove (MovePtr move, Boolean animate);
void	EraseBall (Field field);
void	EraseField (Field field);
void	InvalBall (Field field);
void	ValidBall (Field field);
Point	FieldToCarthCoord (Field f);
Point	FieldToLoc (Field f);

#endif

