// Control.h
// Interface to routines to control the progress of Mike's Life
// Copyright 1995 Michael D. Crawford.  All Rights Reserved.
// 11 Jun 95 Mike Crawford crawford@scruznet.com
//
// Revision History:
// 11 Jun 95	MDC	New today

#define kMaxWindows	16
typedef struct{
	void		*lifeData;			// Storage specific to the life implementation
	void		*lifeModuleProcs;	// Pointer to record of pointers to functions to operate life
	WindowPtr	win;
	long		height;
	long		width;
	FSSpec		file;				// File that the data is kept in, not the module
} tLifeWorldRecord, *tLifeWorldPtr;

void StartRunning( void );
void StopRunning( void );
tLifeWorldPtr NewLifeWorld( void );
void FreeLifeWorld( tLifeWorldPtr worldPtr );
tLifeWorldPtr WinToLifeWorld( WindowPtr win );
void ToggleCell( tLifeWorldPtr worldPtr, long h, long v );
void DrawCell( WindowPtr winPtr, tLifeWorldPtr worldPtr, long h, long v );
void DoLifeNull( void );
void InitControl( void );
