#ifndef __PENT_GRAPHICS_H__
#define __PENT_GRAPHICS_H__

#define kLeftMargin			10
#define kTopMargin			10
#define kRightMargin		10
#define kBottomMargin		10
#define kTileWidth			gThisGameTileSize
#define kTileHeight			gThisGameTileSize
#define kNumColors			8
#define kNumTilesPatterns	13
#define kNumTileColors		6

enum { kWhite=0, kVeryLightGray, kLightGray, kMediumGray, kVeryMediumGray, kMediumDarkGray,
		kVeryDarkGray, kBlack };	/* colors for board */
enum { kLeftEdge=0, kBottomEdge, kFace, kRidgeDark, kRidgeLight, kRidge }; /* colors for tiles */

extern	short			gColorPercent[kNumColors];
extern	RGBColor		gColor[kNumColors];
extern	RGBColor		gTileColor[kNumTileColors];
extern	PixPatHandle	gTilePattern[kNumTilesPatterns];

#ifdef __cplusplus
extern "C" {
#endif

void RefreshTiles(WindowRef theWindow, Point *refresh, short numToRefresh, Boolean removingPiece,
	Boolean refreshFloat);
extern	void DrawOneSpecialTile(WindowRef theWindow, short theDepth, unsigned char boardData[20][20],
	short row, short col, short tileWidth, short tileHeight, short leftMargin, short topMargin,
	Boolean updateOffscreen);
extern	void DrawOneTile(WindowRef theWindow, short theDepth, unsigned char boardData[20][20],
	short row, short col, short tileWidth, short tileHeight, short leftMargin, short topMargin);
extern	void DrawBoardBorder(short theDepth, short numRows, short numColumns,
	short tileWidth, short tileHeight, short leftMargin, short topMargin);
extern	void GetRowColFromPoint(Point thePoint, short *row, short *col, short tileWidth, short tileHeight,
	short leftMargin, short topMargin);
extern	void DrawSoftWindowBorder(WindowRef theWindow, short theDepth, short topMargin, Boolean growIcon);

#ifdef __cplusplus
}
#endif

#endif
