#include "pent meat.h"
#include "pent graphics.h"
#include "pent message.h"
#include "pent endgame.h"
#include "pent globals.h"
#include "sound layer.h"
#include "window layer.h"

static	short			tempPiece[5][5];
static	short			maxi,maxj;

void RemovePiece(WindowRef theWindow)
{
	short			iter, utter;
	Point			refresh[5];
	short			refreshIndex;
	
	refreshIndex=0;
	for (iter=0; iter<gNumRows; iter++)
	{
		for (utter=0; utter<gNumCols; utter++)
		{
			if (gBoard[iter][utter]==kSelectedPiece)
			{
				gBoard[iter][utter]=kEmptyTile;
				refresh[refreshIndex].h=iter;
				refresh[refreshIndex++].v=utter;
			}
		}
	}
	
	gPieceUsed[gSelectedPieceColor]=FALSE;
	for (iter=0; iter<gNumPlayed; iter++)
	{
		if (gPiecesPlayed[iter]==gSelectedPieceColor)
		{
			for (utter=iter; utter<gNumPlayed; utter++)
				gPiecesPlayed[utter]=gPiecesPlayed[utter+1];
			iter=gNumPlayed;
		}
	}
	
	gNumPlayed--;
	gNumHilited=0;
	gSelectedPieceColor=kSelectedTile;
	
	RefreshTiles(theWindow, refresh, 5, TRUE, TRUE);
	DoSound(sound_undo, TRUE);
}

void PlaceUnknownPiece(WindowRef theWindow)
{
	short			pieceNum, err;
	
	if ((err=PlacePiece(theWindow, -1, &pieceNum))!=eNoError)
		DisplayMessage(err);
}

GameError PlacePiece(WindowRef theWindow, short pieceToMatch, short *actualPiece)
{
	short			i, j, shapeTop, shapeLeft;
	Boolean			found;
	Point			refresh[5];
	short			refreshIndex;
	short			pieceNum;
	
	if (gNumHilited==0) return eHighlightFirst;
	
	i=0;
	do
	{
		j=0;
		do
		{
			found=(gBoard[i][j]==kSelectedTile);
			j++;
		}
		while ((!found) && (j<gNumCols));
		i++;
	}
	while ((!found) && (i<gNumRows));
	shapeTop=i-1;
	j=0;
	do
	{
		i=0;
		do
		{
			found=(gBoard[i][j]==kSelectedTile);
			i++;
		}
		while ((!found) && (i<gNumRows));
		j++;
	}
	while ((!found) && (j<gNumCols));
	shapeLeft=j-1;
	for (i=0; i<5; i++)
		for (j=0; j<5; j++)
			tempPiece[i][j]=0;
	i=0;
	do
	{
		j=0;
		do
		{
			if (gBoard[i+shapeTop][j+shapeLeft]==kSelectedTile)
				tempPiece[i][j]=1;
			j++;
		}
		while ((j<5) && (j<gNumCols-shapeLeft));
		i++;
	}		
	while ((i<5) && (i<gNumRows-shapeTop));
		maxi=5;
	while (BlankRow(maxi-1))
		maxi--;
	maxj=5;
	while (BlankCol(maxj-1))
		maxj--;
		found=FALSE;
	
	pieceNum=pieceToMatch;
	if (pieceNum>=0)
		found=MatchPiece(pieceNum);
	else
	{
		pieceNum=0;
		do
		{
			found=MatchPiece(pieceNum);
			pieceNum++;
		}
		while ((pieceNum<kNoTile) && (!found));
		if (found)
			pieceNum--;
	}
	
	if (!found) return ((pieceToMatch==-1) ? eNotAPiece : ePieceNotMatch);
	if (gPieceUsed[pieceNum]) return ePieceUsed;
	
	refreshIndex=0;
	for (j=0; ((j<gNumCols) && (refreshIndex<5)); j++)
	{
		for (i=gNumRows-1; ((i>=0) && (refreshIndex<5)); i--)
		{
			if (gBoard[i][j]==kSelectedTile)
			{
				gBoard[i][j]=pieceNum;
				refresh[refreshIndex].h=i;
				refresh[refreshIndex++].v=j;
			}
		}
	}
	
	SetWindowIsModified(theWindow, TRUE);
	gPieceUsed[pieceNum]=TRUE;
	gPiecesPlayed[gNumPlayed]=pieceNum;
	gNumPlayed++;
	gNumHilited=0;
	RefreshTiles(theWindow, refresh, 5, FALSE, TRUE);
	if (gNumPlayed==12)
		WinGame(theWindow);
	else
		DoSound(sound_placepiece, TRUE);
	*actualPiece=pieceNum;
	return eNoError;
}

Boolean BlankRow(short i)
{
	short			j;
	
	j=0;
	while ((!tempPiece[i][j]) && (j<5))
		j++;
	return (j==5);
}

Boolean BlankCol(short j)
{
	short			i;
	
	i=0;
	while ((!tempPiece[i][j]) && (i<5))
		i++;
	return (i==5);
}

Boolean MatchPiece(short pieceNum)
{
	short			i;
	Boolean		done;
	
	i=0;
	do
	{		
		RotatePiece();
		done=CheckPiece(pieceNum);
		i++;
	}
	while ((!done) && (i<4));
	if (!done)
	{
		FlipPiece();
		i=0;
		do
		{
			RotatePiece();
			done=CheckPiece(pieceNum);
			i++;
		}
		while ((!done) && (i<4));
	}
	return done;
}

Boolean CheckPiece(short pieceNum)
{
	short			i,j;
	Boolean			matched;
	
	i=0;
	do
	{
		j=0;
		do
		{
			matched=(tempPiece[i][j]==gShapes[pieceNum][i][j]);
			j++;
		}
		while ((matched) && (j<5));
		i++;
	}
	while ((matched) && (i<5));
	return matched;
}

void RotatePiece(void)
{
	short			otherPiece[5][5];
	short			i,j;
	short			temp;
	
	for (i=0; i<maxi; i++)
		for (j=0; j<maxj; j++)
			otherPiece[i][j]=tempPiece[i][j];

	for (i=0; i<5; i++)
		for (j=0; j<5; j++)
			tempPiece[i][j]=0;

	for (i=0; i<maxi; i++)
		for (j=0; j<maxj; j++)
			tempPiece[j][maxi-i-1]=otherPiece[i][j];
			
	temp=maxj;
	maxj=maxi;
	maxi=temp;
}

void FlipPiece(void)
{
	short			i,j;
	short			temp;
		
	for (i=0; i<maxi; i++)
		for (j=0; j<maxj/2; j++)
		{
			temp=tempPiece[i][j];
			tempPiece[i][j]=tempPiece[i][maxj-j-1];
			tempPiece[i][maxj-j-1]=temp;
		}
}
