#ifndef _PROGRAM_GLOBALS_H_
#define _PROGRAM_GLOBALS_H_

#define USE_SOUNDS				1
#define USE_MUSIC				1
#define USE_SPEECH				0
#define USE_DRAG				0
#define USE_MERCUTIO			0
#define USE_PRINTING			1
#define SUPPORT_STYLED_TEXT		0
#define USE_SAVE				1
#define USE_WINDOWS_MENU		0
#define USE_ANIMATED_CURSOR		1

#define CREATOR				'PNT5'
#define APPLICATION_NAME	"\pPentominoes"
#define SAVE_DIALOG_PROMPT	"\pSave Pentominoes game as..."
#define BOARDS_FILE_NAME 	"\pPentominoes boards"
#define	SAVE_TYPE			'TEXT'
#define BOARD_FILE_TYPE		'rsrc'
#define	SAVE_VERSION		2

enum
{
	kAboutWindow=0,			/* about box */
	kOtherProductsWindow,	/* other products window */
	kHelpWindow,			/* help window */
	kMainWindow,			/* main graphics window */
	kFloatingWindow,		/* floating icons window */
	kEditorWindow			/* board editor window */
};

enum ErrorTypes
{
	allsWell=0,
	
	/* shell errors */
	kNoMemory,
	kNoMemoryAndQuitting,
	kProgramIntegrityNotVerified,
	kProgramIntegritySet,
	kSystemTooOld,
	userCancelErr,
	
	kCloseGameFirst,
	kCantCreateFile,
	kCantOpenFileToSave,
	kDiskFull,
	kCantWriteFile,
	kCantOpenFileToLoad,
	kCantLoadFile,
	kBadVersion,
	kBadChecksum,
	
	kCantFindBoardsFile,
	kCantCreateBoardsFile,
	kCantDeleteGroup,
	kCantDeleteBoard,
	kDuplicateGroupName,
	kCantCreateGroup,
	kCantCreateBoard,
	kCantReplaceGroup,
	kCantReplaceBoard,
	kCantLoadBoard,
	kCantDeleteLockedBoard,
	kCantEditLockedBoard,
	kCantClearLockedBoard,
	kCantChangeLockedBoard
};

typedef short		ErrorTypes;

#endif
