//	Application.h
//	by Stefan C. Sinclair Copyright:  1995-1996 All rights reserved.


#ifndef __APPLICATION__
#define __APPLICATION__

#include <AppleEvents.h>
#include <Desk.h>
#include <Traps.h>
#include <DiskInit.h>
#include <EPPC.h>
#include <GestaltEqu.h>
#include <Gestalt.h>
#include <Sound.h>
#include <Speech.h>
#include <LowMem.h>
#include <Movies.h>

#include "SpriteWorld.h"
#include "SpriteWorldUtils.h"
#include "Spritez.h"
#include "SpriteError.h"
#include "SpriteFile.h"
#include "SpriteSecretCodes.h"

#define kBackGroundPICTResID		131
#define kHourGlassPICTResID			133

#define kIntroSplashAlertID			130
#define kOpeningSoundResID			128

#define kTextSoundResID				200

#define kRDQTCautionAlertID			130

#define kGameOverManSndID			500
#define kGameOverManPictID			139

#define kMenuBarResID		128
#define kWindowResID		128

#define kAppleMenuID		128
#define kFileMenuID			129
#define kCombatMenuID		130
#define kP1ControlMenuID	131
#define kP2ControlMenuID	132
#define kAdjustSpeedMenuID	133
#define kHiddenMenuID		134

#define kAboutItem				1
#define kInstructionsItem		2
#define kHintsItem				3
#define kMoreItem				4
#define kManoAManoItem			1
#define kTournamentItem			2
#define kQuitItem				4

#define kPlayerOneControlItem	1
#define kPlayerTwoControlItem	2
#define kAdjustSpeedItem		3
#define kSpeechOnOffItem		5
#define kQuickTimeOnOffItem		6


#define kHumanControlItem		1
#define kComputerControlItem	2

#define kThisIsHiddenMenuItem	1
#define kSoundOffItem			2
#define kMaxSoundItem			3
#define kMegaMaxSoundItem		4
#define kNormalSoundItem		5

#define kForeGroundSleepTime	0
#define kBackGroundSleepTime	0

#ifdef __cplusplus
extern "C" {
#endif

void main(void);
void OpeningSplash(void);
Boolean Initialize(void);
Boolean CheckSystem(void);
Boolean CheckMemory(void);
void SetGlobals(void);
void GetStefanStuff(void);
void InitSoundChannel(SndChannelPtr *gChan);
void KillSoundChannel(SndChannelPtr *gChan);
void SetToZero(void *theAddr, Size numBytes);
void Ceremonies(void);
OSErr InstallAppleEventHandlers(void);
void CreateMenuBar(void);
Boolean EnterApplication(void);
void ExitApplication(void);
void EventLoop(void);
void DispatchEvent(EventRecord* event);
void RefreshMainWindow(void);
void HandleMouseEvent(EventRecord* event);
void HandleKeyEvent(char key, short modifiers);
void HandleUpdateEvent(WindowPtr updateWindowP);
void HandleNullEvent(void);
void HandleMenuCommand(long menuItemIdentifier);
void HandleAppleMenuCommand(short menuItem);
void HandleFileMenuCommand(short menuItem);
void HandleCombatMenuCommand(short menuItem);
void HandleP1ControlMenuCommand(short menuItem);
void HandleP2ControlMenuCommand(short menuItem);
void HandleAdjustSpeedMenuCommand(short menuItem);
void HandleHiddenMenuCommand(short menuItem);
void AdjustMenuItems(void);
void enqueue(QNodePtr *headPtr, QNodePtr *tailPtr, QData value);
QData dequeue(QNodePtr *headPtr, QNodePtr *tailPtr);
Boolean isEmpty(QNodePtr headPtr);
void Kenqueue(KNodePtr *headPtr, KNodePtr *tailPtr, KData value);
KData Kdequeue(KNodePtr *headPtr, KNodePtr *tailPtr);
Boolean KisEmpty(KNodePtr headPtr);
pascal OSErr HandleOpenApp(AppleEvent srcAppleEvent, AppleEvent replyAppleEvent, long refCon);
pascal OSErr HandleOpenDoc(AppleEvent srcAppleEvent, AppleEvent replyAppleEvent, long refCon);
pascal OSErr HandlePrintDoc(AppleEvent srcAppleEvent, AppleEvent replyAppleEvent, long refCon);
pascal OSErr HandleQuit(AppleEvent srcAppleEvent, AppleEvent replyAppleEvent, long refCon);
short NumToolboxTraps(void);
TrapType GetTrapType(short trap);
Boolean TrapAvail(short trap);
Boolean MacsBugInstalled(void);
void RDQTConflictCheck(void);
Boolean VMActive(void);
short WhichVMIsInstalled(void);

#endif /* __APPLICATION__ */