/*******************************************************
*** FosselMunchies.c
*** By: Stefan C. Sinclair
*** Copyright  1996 All Rights Reserved Worldwide.
*** Fossel's Background sprite control routines
*******************************************************/

#include "SpriteBackground.h"

extern CWindowPtr	gWindowP;
extern short	gFrameAdvanceTime;
extern RgnHandle gWorkRgn;


void SetupFosselSprite(SpritePtr spriteP)
{
	Rect tempBoundsRect, moveBoundsRect;
	short horizMoveDelta;
	short vertMoveDelta;
	
	moveBoundsRect = gWindowP->portRect;
	tempBoundsRect = moveBoundsRect;
	horizMoveDelta = 0;		//GetRandom(2, 6);
	vertMoveDelta =	0;		//GetRandom(2, 6);
	
	// calculate the movement boundary rectangle
	InsetRect(&tempBoundsRect, horizMoveDelta, vertMoveDelta);

	// set the sprites movement characteristics
	SWSetSpriteMoveBounds(spriteP, &tempBoundsRect);
	SWSetSpriteMoveDelta(spriteP, horizMoveDelta, vertMoveDelta);
	SWSetSpriteMoveProc(spriteP, FosselMoveProc); // mine
	// Maximum Speed!!!
	SWSetSpriteMoveTime(spriteP, 0); // Stationary
	SWSetSpriteFrameTime(spriteP, 5*5*(20-gFrameAdvanceTime-1)); // 1/5 speed
	SWSetSpriteFrameRange(spriteP, 0, 1); // 2 frames
	SWSetSpriteFrameAdvance(spriteP, 1);
	// Default draw proc = CopyBits
	SWSetSpriteCollideProc(spriteP, FosselSpriteCollideProc); // mine
	// set the sprites initial location
	SWSetSpriteLocation(spriteP, 240, (moveBoundsRect.bottom - 140));
}

// FosselSpriteCollideProc----------------------------------------------------------------
void FosselSpriteCollideProc(SpritePtr srcSpriteP,SpritePtr dstSpriteP,Rect* sectRect)
{
	return; // bare minimum!
}

/** FosselMoveProc **/
// Here, reset sprite frame range as necessary depending on location.
SW_FUNC void FosselMoveProc(SpritePtr srcSpriteP, Point* spritePoint)
{
	return; // bare minimum!
}