/*******************************************************
*** SpriteBackground.c
*** By: Stefan C. Sinclair
*** Copyright  1996 All Rights Reserved Worldwide.
*** Brief description here
*******************************************************/

#include "SpriteBackground.h"

extern CWindowPtr	gWindowP;
extern short	gFrameAdvanceTime;
extern RgnHandle gWorkRgn;

// CreateBackgroundSprite
OSErr CreateBackgroundSprite(void *spriteStorageP, short backgroundSpriteID)
{
	SpritePtr	tempSpriteP;
	short	firstPICTID, firstMaskID, numFrames;
	OSErr	err;
	
	switch(backgroundSpriteID)
	{
		case kChevyGnuoySpriteID:
			firstPICTID = kChevyGnuoyPICTID;
			firstMaskID = kChevyGnuoyMaskPICTID;
			numFrames = 2;
			break;
		case kDeathTrainSpriteID:
			firstPICTID = kDeathTrainPICTID;
			firstMaskID = kDeathTrainMaskPICTID;
			numFrames = 1;
			break;
		case kFosselSpriteID:
			firstPICTID = kFosselPICTID;
			firstMaskID = kFosselMaskPICTID;
			numFrames = 2;
			break;
		case kSafariSpriteID:
			firstPICTID = kSafariPICTID;
			firstMaskID = kSafariMaskPICTID;
			numFrames = 13;
			break;
		default:
			firstPICTID = kChevyGnuoyPICTID;
			firstMaskID = kChevyGnuoyMaskPICTID;
			numFrames = 2;
			break;
	}
	// Lien Gnouy in the Chevy
	err = SWCreateSpriteFromPictResource(&tempSpriteP,spriteStorageP,
			firstPICTID, firstMaskID, numFrames,kRegionMask);
	return err;
}

void SetupBackgroundSprite(SpritePtr spriteP, short backgroundSpriteID)
{
	switch(backgroundSpriteID)
	{
		case kChevyGnuoySpriteID:
			SetupChevyGnuoySprite(spriteP);
			break;
		case kDeathTrainSpriteID:
			SetupDeathTrainSprite(spriteP);
			break;
		case kFosselSpriteID:
			SetupFosselSprite(spriteP);
			break;
		case kSafariSpriteID:
			SetupSafariSprite(spriteP);
			break;
		default:
			SetupChevyGnuoySprite(spriteP);
			break;
	}
}