/*******************************************************
*** SpriteBackground.h
*** By: Stefan C. Sinclair
*** Copyright  1996 All Rights Reserved Worldwide.
*** Brief description here
*******************************************************/

#ifndef __SPRITEBACKGROUND__
#define __SPRITEBACKGROUND__

#ifndef __SPRITEWORLD__
#include "SpriteWorld.h"
#endif

#ifndef __SPRITE__
#include "Sprite.h"
#endif

#define kFirstBackgroundSpriteID	0

#define kChevyGnuoySpriteID			0
#define kChevyGnuoyPICTID			500
#define kChevyGnuoyMaskPICTID		510

#define kDeathTrainSpriteID			1
#define kDeathTrainPICTID			5000
#define kDeathTrainMaskPICTID		5001

#define kFosselSpriteID				2
#define kFosselPICTID				600
#define kFosselMaskPICTID			602

#define kSafariSpriteID				3
#define kSafariPICTID				700
#define kSafariMaskPICTID			720

#define kLastBackgroundSpriteID		3

//Function protos
OSErr CreateBackgroundSprite(void *spriteStorageP, short backgroundSpriteID);
void SetupBackgroundSprite(SpritePtr spriteP, short backgroundSpriteID);

//ChevyGnuoy
void SetupChevyGnuoySprite(SpritePtr spriteP);
void ChevyGnuoySpriteCollideProc(SpritePtr srcSpriteP,SpritePtr dstSpriteP,Rect* sectRect);
SW_FUNC void ChevyGnuoyMoveProc(SpritePtr srcSpriteP, Point* spritePoint);

//DeathTrain
void SetupDeathTrainSprite(SpritePtr spriteP);
void DeathTrainSpriteCollideProc(SpritePtr srcSpriteP,SpritePtr dstSpriteP,Rect* sectRect);
SW_FUNC void DeathTrainMoveProc(SpritePtr srcSpriteP, Point* spritePoint);

//Fossel Munchies
void SetupFosselSprite(SpritePtr spriteP);
void FosselSpriteCollideProc(SpritePtr srcSpriteP,SpritePtr dstSpriteP,Rect* sectRect);
SW_FUNC void FosselMoveProc(SpritePtr srcSpriteP, Point* spritePoint);

//Safari
void SetupSafariSprite(SpritePtr spriteP);
void SafariSpriteCollideProc(SpritePtr srcSpriteP,SpritePtr dstSpriteP,Rect* sectRect);
SW_FUNC void SafariMoveProc(SpritePtr srcSpriteP, Point* spritePoint);

#endif // end SpriteBackground