/*** SpriteError.h by Stefan C. SInclair Copyright  1995-6 All rights reserved. ***/

#ifndef _SPRITEERROR_
#define _SPRITEERROR_

#include "Speech.h"

#define kSeriousDamageString "\pCould not even get error string!\rThis application is seriously damaged!"

/*** For DoError fxn ***/
#define kDoErrorAlertID		150
#define kDoErrorStringListResID		kDoErrorAlertID


#define kSoundUPPError				1
#define kCouldNotCreateSprites		2
#define kCouldNotCreatePlayer1Sprite	3
#define kCouldNotCreatePlayer2Sprite	4
#define kCouldNotCreateASoundChannel	5
#define kUnknownSpriteInGame			6
#define kNULLSoundHandle				7
#define kNULLSoundChannel				8
#define kCouldNotFlushSoundChannel		9
#define kCouldNotQuietSoundChannel		10
#define kCouldNotGetSoundHeaderOffset	11
#define kSoundBufferError				12
#define kNoEnterMovies					13
#define kNoFileSpecForMovie				14
#define kNoOpenFile						15
#define kNoMovieInFile					16
#define kGeneralMemoryError				17
#define kCouldNotEnterSW				18
#define kPlayer1NotLoaded				19
#define kPlayer2NotLoaded				20
#define kCombatZoneNotLoaded			21
#define kCouldNotCreateBackGroundSprite	22
#define kCanNotSetVolume				23
#define kBadSoundChannel				24
#define kUnknownError					25
#define kNeedMonitor256Colors			26
#define kQuickTimeError					27
#define kResError						28
#define kNoQuickTimeInstalled			29
#define kNeedSoundMgr3ForMegaVolume		30

/*** For ChoiceAlert fxn ***/
#define kChoiceAlertResID				200
#define kChoiceStringListResID			kChoiceAlertResID

#define kItemNumber2		2

#define kWantToQuit						1
#define kTournamentCoice1				2
#define kTournamentCoice2				3
#define kTournamentCoice3				4
#define kWantToGoToNextRound			5

/*** For CantRunOnThisMachine ***/
#define kErrorAlertResID				128
#define kCantRunAlertResID				129
#define kErrorStringListResID			128
#define kUnknownErrorStringIndex		1
#define kCantFindResourceStringIndex	2
#define kNotEnoughMemoryStringIndex		3
#define kNeedSoundMgr3					4
#define kNeedSystem7					5
#define kNeedQuickTime					6
#define kNeedSpeechMgr					7
#define kNeedColorQuickDraw				8
#define kNeed14inchMonitor				9

/*** For Message Alerts ***/
#define kMessageAlertID					131
#define kMessageStringListID			131
#define kSelectPlayer1					1
#define kSelectPlayer2					2
#define kSelectCombatZone				3
#define kBetaNotice						4
#define kFeatureNotAvailable			5
#define kSpeechOn						6
#define kSpeechOff						7
#define kQTOn							8
#define kQTOff							9

// Function Protos
void DoMessage( short message);
void DoError( short error, Boolean fatal);
Boolean ChoiceAlert(short choice);
void ErrorAlert(OSErr err, short errorStringIndex);
void CantFindResource(void);
void CantRunOnThisMachine(short whyNot, Boolean fatal);

#endif /* SPriteError */