/*
 *	Project:		SimpleApp
 *
 *	Filename: 		SimpleAppInit.c
 *
 *	Author: 		Marco Piovanelli
 *
 *	Revision History:
 *
 *			1996.05.24				MP		created this file
 *
 */

#include "SimpleApp.h"

OSErr Initialize ( )
{
	OSErr err ;

	MaxApplZone ( ) ;
	
	for ( int index = 0 ; index < kMoreMasters ; index ++ )
	{
		MoreMasters ( ) ;
	}
	
	InitGraf ( & qd . thePort ) ;
	InitWindows ( ) ;
	InitMenus ( ) ;
	TEInit ( ) ;
	InitDialogs ( nil ) ;
	InitCursor ( ) ;
	FlushEvents ( everyEvent, 0 ) ;
	
	if ( InfoScrap ( ) -> scrapSize > kScrapThreshold )
	{
		UnloadScrap ( ) ;
	}
	
	if ( ( err = InitializeEvents ( ) ) != noErr )
		return err ;
	
	if ( ( err = InitializeMenus ( ) ) != noErr )
		return err ;
	
	return noErr ;
}

OSErr Finalize ( )
{
	return noErr ;
}
